<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
require_once 'Entity.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

class ForfaitEntity extends Entity
{
    private $id;

    private $token;

    private $domain;

    private $date_debut;

    private $date_fin;

    private $credit;

    private $credit_used_period;

    private $credit_used_total;

    private $compte;

    private $trial;

    private $canDownload;

    private $active_videos;

    public function toArray()
    {
        $result = [];

        $result['id'] = $this->id;
        $result['token'] = $this->token;
        $result['domain'] = $this->domain;
        $result['date_debut'] = $this->date_debut;
        $result['date_fin'] = $this->date_fin;
        $result['credit'] = $this->credit;
        $result['credit_used_period'] = $this->credit_used_period;
        $result['credit_used_total'] = $this->credit_used_total;
        $result['trial'] = $this->trial;
        $result['canDownload'] = $this->canDownload;
        $result['active_videos'] = $this->active_videos;

        return $result;
    }

    public function fromArray($array)
    {
        if (isset($array['id'])) {
            $this->id = $array['id'];
            $this->token = $array['token'];
            $this->domain = $array['domain'];
            $this->date_debut = $array['date_debut'];
            $this->date_fin = $array['date_fin'];
            $this->credit = $array['credit'];
            $this->credit_used_period = $array['credit_used_period'];
            $this->credit_used_total = $array['credit_used_total'];
            $this->trial = $array['trial'];
            $this->canDownload = $array['canDownload'];
            $this->active_videos = $array['active_videos'];
            return true;
        }
        return false;
    }

    /**
     * @return null
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param null $id
     *
     * @return ForfaitEntity
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * @return null
     */
    public function getCanDownload()
    {
        return $this->canDownload;
    }

    /**
     * @param null $canDownload
     *
     * @return bool
     */
    public function setCanDownload($canDownload)
    {
        $this->canDownload = $canDownload;

        return $this;
    }

    /**
     * @return null
     */
    public function getActiveVideos()
    {
        return $this->active_videos;
    }

    /**
     * @param null $canDownload
     *
     * @return bool
     */
    public function setActiveVideos($active_videos)
    {
        $this->active_videos = $active_videos;

        return $this;
    }

    /**
     * @return null
     */
    public function getToken()
    {
        return $this->token;
    }

    /**
     * @param null $token
     *
     * @return ForfaitEntity
     */
    public function setToken($token)
    {
        $this->token = $token;

        return $this;
    }

    /**
     * @return null
     */
    public function getDomain()
    {
        return $this->domain;
    }

    /**
     * @param null $domain
     *
     * @return ForfaitEntity
     */
    public function setDomain($domain)
    {
        $this->domain = $domain;

        return $this;
    }

    /**
     * @return null
     */
    public function getDateDebut()
    {
        return $this->date_debut;
    }

    /**
     * @param null $date_debut
     *
     * @return ForfaitEntity
     */
    public function setDateDebut($date_debut)
    {
        $this->date_debut = $date_debut;

        return $this;
    }

    public function isExpired()
    {
        return strtotime($this->date_fin) - time() < 0;
    }

    /**
     * @return null
     */
    public function getDateFin()
    {
        return $this->date_fin;
    }

    /**
     * @param null $date_fin
     *
     * @return ForfaitEntity
     */
    public function setDateFin($date_fin)
    {
        $this->date_fin = $date_fin;

        return $this;
    }

    /**
     * @return null
     */
    public function getCredit()
    {
        return $this->credit;
    }

    /**
     * @param null $credit
     *
     * @return ForfaitEntity
     */
    public function setCredit($credit)
    {
        $this->credit = $credit;

        return $this;
    }

    /**
     * @return null
     */
    public function getCreditUsedPeriod()
    {
        return $this->credit_used_period;
    }

    /**
     * @param null $credit_used_period
     *
     * @return ForfaitEntity
     */
    public function setCreditUsedPeriod($credit_used_period)
    {
        $this->credit_used_period = $credit_used_period;

        return $this;
    }

    /**
     * @return null
     */
    public function getCreditUsedTotal()
    {
        return $this->credit_used_total;
    }

    /**
     * @param null $credit_used_total
     *
     * @return ForfaitEntity
     */
    public function setCreditUsedTotal($credit_used_total)
    {
        $this->credit_used_total = $credit_used_total;

        return $this;
    }

    /**
     * @return CompteEntity|null
     */
    public function getCompte()
    {
        return $this->compte;
    }

    /**
     * @param CompteEntity $compte
     *
     * @return ForfaitEntity
     */
    public function setCompte($compte)
    {
        $this->compte = $compte;

        return $this;
    }

    /**
     * @return null
     */
    public function getTrial()
    {
        return $this->trial;
    }

    /**
     * @param null $trial
     */
    public function setTrial($trial)
    {
        $this->trial = filter_var($trial, FILTER_VALIDATE_BOOLEAN);
    }
}
