<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
require_once __DIR__ . '/../../../Kernel/API/Entity/GabaritEntity.php';
require_once __DIR__ . '/../../../Kernel/API/Linker/API_Linker.php';
require_once __DIR__ . '/../../../Kernel/Translations/DigitalSignageTranslate.php';
require_once 'Manager.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

class GabaritManager extends Manager
{
    // Singleton
    private static $instance;

    public function __construct()
    {
    }

    public static function instance()
    {
        if (self::$instance == null) {
            self::$instance = new GabaritManager();
        }

        return self::$instance;
    }

    private $managerEntityName = 'Gabarit';

    private $gabarits = [];

    /**
     * @return false|GabaritEntity[]
     */
    public function getGabarits()
    {
        if (empty($this->gabarits)) {
            try {
                $this->gabarits = API_Linker::get_entitys($this->managerEntityName, GabaritEntity::class, ForfaitManager::instance()->getToken());

                if (!$this->gabarits) {
                    $this->gabarits = [];
                }
            } catch (DigitalSignageException $e) {
                $this->gabarits = [];
                $this->addUserMessage(DigitalSignageTranslate::getTraduction('error_api', $e->getMessage()));
            }
        }

        return array_values($this->gabarits);
    }

    public function getGabarit($id)
    {
        foreach ($this->getGabarits() as $gabarit) {
            if ($gabarit->getId() == $id) {
                return $gabarit;
            }
        }

        return false;
    }
}
