<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
require_once __DIR__ . '/../../../Kernel/API/Entity/ForfaitEntity.php';
require_once 'Manager.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

class UpdateManager extends Manager
{
    private static $managerEntityName = 'Update';

    public static function get($currentVersion)
    {
        return self::getLastVersionUpdate($currentVersion);
    }

    private static function getLastVersionUpdate($currentversion)
    {
        $datas = self::getData($currentversion);
        if ($datas && !empty($datas)) {
            return end($datas);
        }

        return false;
    }

    private static function getData($currentVersion)
    {
        $demande = API_Linker::get(self::$managerEntityName . '?version=' . $currentVersion, ForfaitManager::instance()->getToken());
        if ($demande->getResponseCode() == 200) {
            return $demande->getDatas();
        }

        return false;
    }
}
