<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

if (file_exists('./../../../../../wp-load.php')) {
    define('WP_USE_THEMES', false); // Don't load theme support functionality
    require './../../../../../wp-load.php';
} else {
    require './../../../../../config/config.inc.php';
    require './../../../../../init.php';
    require_once './../../../digitalsignage.php';
    DigitalSignageTranslate::setLang(substr(get_bloginfo('language'), 0, 2));
    refresh_local_token();
}
require_once __DIR__ . '/../../Classes/Tools_DS4.php';
require_once __DIR__ . '/../../Classes/Wp_caller.php';
require_once __DIR__ . '/../../Kernel/API/Manager/AutomatisationManager.php';
require_once __DIR__ . '/../../Kernel/API/Manager/DemandeManager.php';
require_once __DIR__ . '/../../Classes/DisplayedVideoProduct.php';
require_once __DIR__ . '/../../Kernel/API/Manager/DigitalSignageException.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

// Point d'entrer de ma methode de cron
new CronJobController();

class CronJobController
{
    private $wp_caller;

    public const LAST_CALL = 'DigitalSignage_cron_last_call';

    public const LAST_CALL_EXECUTION_UPDATE_VIDEOS = 'DigitalSignage_cron_last_update';

    public const LAST_CALL_EXECUTION_RUN_AUTO_DAY = 'DigitalSignage_cron_auto_last_update';

    public const TIME_DIFF_SEC_UPDATE_VIDEOS = 2;

    public function __construct()
    {
        ob_get_clean();
        $this->wp_caller = new Wp_caller();
        $this->wp_caller->save_data(self::LAST_CALL, date('Y-m-d H:i:s')); // Date de la derniere update lancé par le cron

        $this->cronUpdateVideos();
        $this->cronUpdateAuto();
    }

    private function uploadVideoYoutube($videoUrl, $youtube_data, $id_demande)
    {
        // Vérifier que la case à cocher "upload youtube" l'est
        echo 'debut uploadVideoYoutube avec parametre ' . $videoUrl . '<br/>';
        $forfait = ForfaitManager::instance()->getForfait(ForfaitManager::instance()->getToken(), true);
        $dataYoutube = Wp_caller::getInstance()->get_data(Wp_caller::YOUTUBE_JSON);
        // var_dump($dataYoutube);
        if ($forfait && $dataYoutube) {
            $idForfait = $forfait->getId();
            echo 'idForfait : ' . $idForfait . '<br/>';
            echo 'youtube actif : ' . $dataYoutube['youtube_active'] . '<br/>';

            if ($dataYoutube['youtube_active']) {
                // Vérifier que l'état du compte est à 3
                // Donner l'ordre

                $ch = curl_init();
                $responseAPI = $this->callYoutubeAPI(['action' => 'getStatus', 'idForfait' => $idForfait]);

                if ($responseAPI != null) {
                    $jsonAPI = json_decode($responseAPI, true);
                    if ($jsonAPI['response_code'] == 200) {
                        $stateOauth = $jsonAPI['datas']['state'];
                        echo 'state : ' . $stateOauth;
                        if ($stateOauth == 3) {
                            // file_put_contents('logagdemandemanager.txt','uploadVideoYoutube'."\n",FILE_APPEND);
                            // file_put_contents('logagdemandemanager.txt',json_encode($youtube_data)."\n",FILE_APPEND);
                            $this->callYoutubeAPI(['action' => 'uploadVideo', 'idForfait' => $idForfait, 'id_demande' => $id_demande, 'urlVideo' => $videoUrl, 'titleVideo' => $youtube_data['titleVideo'], 'summaryVideo' => $youtube_data['summaryVideo'], 'tagsVideo' => $youtube_data['tagsVideo']]);
                            // $this->callYoutubeAPI(array("action"=>"uploadVideo","idForfait"=>$idForfait,"urlVideo"=>$videoUrl,"titleVideo"=>"title","summaryVideo"=>"summary"));
                            // file_put_contents('logagdemandemanager.txt','uploadVideoYoutube FAIT'."\n",FILE_APPEND);
                        }
                    }
                }
            }
        }
    }

    private function callYoutubeAPI($datas)
    {
        $ch = curl_init();
        $responseAPI = null;

        try {
            curl_setopt($ch, CURLOPT_URL, 'https://ip120.ip-5-196-165.eu/API_v2/Youtube/');
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $datas);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
            curl_setopt($ch, CURLOPT_TIMEOUT, 5);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_MAXREDIRS, 1);
            // curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);

            $response = curl_exec($ch);

            if (curl_errno($ch)) {
                echo curl_error($ch);

                // file_put_contents('logagdemandemanager.txt','callYoutubeAPI ERREUR'."\n",FILE_APPEND);
                // file_put_contents('logagdemandemanager.txt',curl_error($ch)."\n",FILE_APPEND);

                exit;
            }

            $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            if ((int) $http_code == 200) {
                // file_put_contents('logagdemandemanager.txt','callYoutubeAPI OK'."\n",FILE_APPEND);
                // file_put_contents('logagdemandemanager.txt',json_encode($response)."\n",FILE_APPEND);

                $responseAPI = $response;
            } else {
                // file_put_contents('logagdemandemanager.txt','callYoutubeAPI OK pas 200'."\n",FILE_APPEND);
                // file_put_contents('logagdemandemanager.txt',$http_code."\n",FILE_APPEND);
                // file_put_contents('logagdemandemanager.txt',json_encode($datas)."\n",FILE_APPEND);
                // file_put_contents('logagdemandemanager.txt','callYoutubeAPI response'."\n",FILE_APPEND);
                // file_put_contents('logagdemandemanager.txt',json_encode($response)."\n",FILE_APPEND);
                echo 'Ressource introuvable : ' . $http_code;
            }
        } catch (Throwable $th) {
            throw $th;
        } finally {
            curl_close($ch);
        }

        return $responseAPI;
    }

    private function cronUpdateVideos()
    {
        $date_update = date('Y-m-d H:i:s');
        if (!$this->wp_caller->get_data(self::LAST_CALL_EXECUTION_UPDATE_VIDEOS)) {
            $this->wp_caller->save_data(self::LAST_CALL_EXECUTION_UPDATE_VIDEOS, $date_update);
        }
        $date_last_update = $this->wp_caller->get_data(self::LAST_CALL_EXECUTION_UPDATE_VIDEOS);
        if (abs(strtotime($date_update) - strtotime($date_last_update)) >= self::TIME_DIFF_SEC_UPDATE_VIDEOS) {
            $this->wp_caller->save_data(self::LAST_CALL_EXECUTION_UPDATE_VIDEOS, $date_update);
            $this->updateVideos();
            $this->updateVideosYoutube();
        }
    }

    private function cronUpdateAuto()
    {
        if (!$this->wp_caller->get_data(self::LAST_CALL_EXECUTION_RUN_AUTO_DAY)) {
            $this->wp_caller->save_data(self::LAST_CALL_EXECUTION_RUN_AUTO_DAY, date('d'));
        }
        $date_last_update_auto = $this->wp_caller->get_data(self::LAST_CALL_EXECUTION_RUN_AUTO_DAY);
        if ($date_last_update_auto != date('d')) {
            $this->wp_caller->save_data(self::LAST_CALL_EXECUTION_RUN_AUTO_DAY, date('d'));
            $this->updateAuto();
        }
    }

    private function updateAuto()
    {
        try {
            $automatisations = AutomatisationManager::set(Wp_caller::getInstance())->get_automatisations();
            foreach ($automatisations as $automatisation) {
                if ($automatisation->getHookSell()) {
                    $productsIds = $this->get_best_selling_products($automatisation->getNbProduit(), $automatisation->getNbJours());

                    foreach ($productsIds as $productId) {
                        $post = WP_Post::get_instance($productId);
                        $automatisationsRunner = new AutomatisationHookControllerCreation();
                        $automatisationsRunner->automatisationJob($automatisation, $post);
                    }
                }
            }
        } catch (DigitalSignageException $e) {
        }
    }

    /**
     * @param $limit <1 = pas de limite
     *
     * @return int[]
     */
    public function get_best_selling_products($limit = '-1', $nbJoursPreviusStart = 0)
    {
        $limit_clause = (int) $limit <= 0 ? '' : 'LIMIT ' . (int) $limit;
        $curent_month = date('Y-m-d', strtotime('-' . $nbJoursPreviusStart . ' days'));

        $dbprefix = WpDbClassInterface::getInstance()->prefix;
        $idsArray = WpDbClassInterface::getInstance()->get_results("
        SELECT p.ID as id
        FROM {$dbprefix}posts p
        INNER JOIN {$dbprefix}woocommerce_order_itemmeta oim
            ON p.ID = oim.meta_value
        INNER JOIN {$dbprefix}woocommerce_order_itemmeta oim2
            ON oim.order_item_id = oim2.order_item_id
        INNER JOIN {$dbprefix}woocommerce_order_items oi
            ON oim.order_item_id = oi.order_item_id
        INNER JOIN {$dbprefix}posts as o
            ON o.ID = oi.order_id
        WHERE p.post_type = 'product'
        AND p.post_status = 'publish'
        AND o.post_status IN ('wc-processing','wc-completed')
        AND o.post_date >= '$curent_month'
        AND oim.meta_key = '_product_id'
        AND oim2.meta_key = '_qty'
        GROUP BY p.ID
        ORDER BY COUNT(oim2.meta_value) + 0 DESC
        $limit_clause
    ");

        return array_map(
            function ($el) {
                return (int) $el->id;
            },
            $idsArray
        );
    }

    // met a jour les youtube_id pour avoir les liens vers les videos
    private function updateVideosYoutube()
    {
        $forfait = ForfaitManager::instance()->getForfait(ForfaitManager::instance()->getToken(), true);
        $dataYoutube = Wp_caller::getInstance()->get_data(Wp_caller::YOUTUBE_JSON);
        // var_dump($dataYoutube);
        if ($forfait && $dataYoutube) {
            $idForfait = $forfait->getId();
            // echo 'idForfait : ' . $idForfait . '<br/>';
            // echo 'youtube actif : ' . $dataYoutube['youtube_active'] . '<br/>';

            // Vérifier que l'état du compte est à 3
            // Donner l'ordre

            $ch = curl_init();
            $responseAPI = $this->callYoutubeAPI(['action' => 'getStatus', 'idForfait' => $idForfait]);
            if ($responseAPI != null) {
                $jsonAPI = json_decode($responseAPI, true);
                if ($jsonAPI['response_code'] == 200) {
                    $stateOauth = $jsonAPI['datas']['state'];
                    // echo 'state : ' . $stateOauth;
                    if ($stateOauth == 3) {
                        // pour chaque video avec le status completed et le youtube_data !='' et youtube_id ='' on interroge l'api pour obtenir le youtube_id
                        $demandeC = new DemandeManager($this->wp_caller);
                        $videosNotCompleted = $demandeC->getLocalDemandes("SELECT * FROM %s WHERE `flag` = 'completed' AND `youtube_data` != '' AND youtube_id=''");
                        $haveDemandeInProcess = false;

                        foreach ($videosNotCompleted as $videoNotCompleted) {
                            $haveDemandeInProcess = true;
                            echo 'obtenir le youtube_id de la demande id:' . $videoNotCompleted->getIdDemande() . ' <br>';

                            $responseAPI = $this->callYoutubeAPI(['action' => 'statusVideoYoutube', 'id_demande' => $videoNotCompleted->getIdDemande()]);
                            if ($responseAPI != null) {
                                $jsonAPI = json_decode($responseAPI, true);

                                $sqlRequest = "UPDATE %s SET
										`youtube_id`='" . pSQL($jsonAPI['datas']['idvideo']) . "' WHERE `id_demande`='" . $videoNotCompleted->getIdDemande() . "' ";

                                $this->wp_caller->execute_video_request($sqlRequest);
                            }
                        }

                        if (!$haveDemandeInProcess) {
                            echo '<br>updateVideosYoutube -> Aucune demande a mettre a jours <br>';
                        }
                    }
                }
            }
        }
    }

    // Update des videos tous les self::TIME_DIFF_SEC_UPDATE_VIDEOS seconds
    private function updateVideos()
    {
        $demandeC = new DemandeManager($this->wp_caller);
        $videosNotCompleted = $demandeC->getLocalDemandes("SELECT * FROM %s WHERE `flag` != 'completed' OR `video_url` = '' ");
        $haveDemandeInProcess = false;

        foreach ($videosNotCompleted as $videoNotCompleted) {
            $haveDemandeInProcess = true;

            try {
                echo '<br><br><br> -> update demande ' . $videoNotCompleted->getIdDemande() . ' <br>';

                $demandes = $demandeC->getDemandes(['id_demande=' . $videoNotCompleted->getIdDemande()]);
                foreach ($demandes as $demande) {
                    echo '-> Recupération <br>';

                    $urlVideo = '';

                    if ($demande->getFlag() == 'completed') {
                        $videoUrl = $demande->getVideoUrl();

                        $freeDiskSpace = disk_free_space('/') / 1024 / 1024 / 1024;
                        $saveDiskSpace = Wp_caller::getInstance()->get_data(Wp_caller::DISK_FREE_SPACE);

                        $videoFileName = $this->slugifyVideoName($demande->getVideoName());

                        if ($freeDiskSpace > $saveDiskSpace) {
                            echo '-> Téléchargement <br>';

                            $videoRootDirectory = __DIR__ . '/../../../Videos';

                            $isUploadedMp4 = false;
                            // $isUploadedOGV = false;
                            $errorMessages = [];

                            echo "-> Fichier racine $videoRootDirectory <br>";
                            if (!file_exists($videoRootDirectory)) {
                                echo '-> Fichier racine introuvable <br>';
                                mkdir($videoRootDirectory);
                                if (!chmod($videoRootDirectory, 0777)) {
                                    $errorMessages[] = '<br>' . DigitalSignageTranslate::getTraduction('Modif_video_directory_impossible');

                                    continue;
                                }
                                echo '-> Fichier racine Créé <br>';
                            }

                            $videoDirectory = $videoRootDirectory . '/' . $demande->getIdDemande() . '/';

                            echo "-> Fichier video $videoRootDirectory <br>";
                            if (!file_exists($videoDirectory)) {
                                echo '-> Fichier video introuvable <br>';
                                mkdir($videoDirectory);
                                if (!chmod($videoDirectory, 0777)) {
                                    $errorMessages[] = '<br>' . DigitalSignageTranslate::getTraduction('Modif_video_directory_impossible');

                                    continue;
                                }
                                echo '-> Fichier video Créé <br>';
                            }

                            if (file_exists($videoDirectory)) {
                                echo '-> Debut download video <br>';

                                if (file_put_contents($videoDirectory . $videoFileName . '.mp4', Tools::file_get_contents($videoUrl))) {
                                    if (!chmod($videoDirectory . $videoFileName . '.mp4', 0777)) {
                                        // impossible de changer les droits de la vidéo en mp4
                                        $errorMessages[] = '<br>' . DigitalSignageTranslate::getTraduction('Telechargement_video_impossible', 'mp4');
                                        echo '-> Fin download video mp4 <br>';
                                    } else {
                                        $isUploadedMp4 = true;
                                    }
                                    $this->uploadVideoYoutube($videoUrl, json_decode($demande->getYoutubeData(), true), $demande->getIdDemande());
                                } else {
                                    // impossible d'uploader la vidéo en mp4
                                    $errorMessages[] = '<br>' . DigitalSignageTranslate::getTraduction('Modif_video_impossible', 'mp4');
                                }

                                /*if (file_put_contents($videoDirectory . $videoFileName . ".ogv", file_get_contents(str_replace(".mp4", ".ogv", $videoUrl)))) {
                                    if (!chmod($videoDirectory . $videoFileName . ".ogv", 0777)) {
                                        // impossible de changer les droits de la vidéo en ogv
                                        $errorMessages[] = "<br>" . DigitalSignageTranslate::getTraduction("Telechargement_video_impossible", "ogv");
                                        echo "-> Fin download video ogv <br>";

                                    } else {
                                        $isUploadedOGV = true;
                                    }
                                } else {
                                    // impossible d'uploader la vidéo en ogv
                                    $errorMessages[] = "<br>" . DigitalSignageTranslate::getTraduction("Modif_video_impossible", "ogv");
                                }*/

                                echo '-> Fin download video <br>';
                            } else {
                                // impossible de créer le dossier racine des vidéos ~/digitalsignage/Videos
                                $errorMessages[] = '<br>' . DigitalSignageTranslate::getTraduction('Crea_video_directory_impossible');
                            }

                            if ($isUploadedMp4/* && $isUploadedOGV */) {
                                echo '-> Tous les fichiers ont été telechargé <br>';

                                if (/* !file_exists($videoDirectory . $videoFileName . ".ogv") || */
                                    !file_exists($videoDirectory . $videoFileName . '.mp4')) {
                                    $demande->setFlag('error');
                                } else {
                                    $urlVideo = Tools_DS4::getModuleVideoUrl() . $demande->getIdDemande() . '/' . $videoFileName . '.mp4';
                                    DisplayedVideoProduct::setDisplayedVideoProduct($demande->getProductId(), $demande->getIdDemande());
                                    echo "-> Url vidéo $urlVideo <br>";
                                }
                            } else {
                                if ($errorMessages) {
                                    $demande->setFlag('error;' . implode(' ', $errorMessages));
                                } else {
                                    $demande->setFlag('error');
                                }
                            }
                        } else {
                            $demande->setFlag('noSpace');
                        }
                    }

                    if ($demande->getFlag() !== $videoNotCompleted->getFlag()) {
                        echo '-> Debut enregistrement bdd video <br>';

                        $sqlRequest = "UPDATE %s SET
					            `data`='" . pSQL($demande->getData()) . "',`flag`='" . $demande->getFlag() . "',`video_name`='" . $demande->getVideoName() . "',`video_comment`='" . $demande->getVideoComment() . "',
					            `date_begin`='" . $demande->getDateBegin() . "',`automatique`='" . $demande->getAutomatique() . "',`date_end`='" . $demande->getDateEnd() . "',`date_demande`='" . $demande->getDateDemande() . "',
					            `gabarit`='" . $demande->getGabarit() . "',`video_url`='" . $urlVideo . "',`video_hash`='" . $demande->getVideoHash() . "',
					            `product_id`='" . $demande->getProductId() . "' WHERE `id_demande`='" . $demande->getIdDemande() . "' ";

                        $this->wp_caller->execute_video_request($sqlRequest);

                        echo '<br><pre>';
                        var_dump($sqlRequest);
                        echo '</pre><br>';

                        echo '-> Fin enregistrement bdd video <br>';
                    } else {
                        echo '-> Rien de nouveau a enregistrer <br>';
                    }
                }
            } catch (DigitalSignageException $e) {
                exit($e->getMessage());
            }
        }

        if (!$haveDemandeInProcess) {
            echo '-> Aucune demande a mettre a jours <br>';
        }
    }

    public static function slugifyVideoName($text, $divider = '-')
    {
        // replace non letter or digits by divider
        $text = preg_replace('~[^\pL\d]+~u', $divider, $text);

        // transliterate
        $text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);

        // remove unwanted characters
        $text = preg_replace('~[^-\w]+~', '', $text);

        // trim
        $text = trim($text, $divider);

        // remove duplicate divider
        $text = preg_replace('~-+~', $divider, $text);

        // lowercase
        $text = strtolower($text);

        if (empty($text)) {
            return 'video';
        }

        return $text;
    }
}
