/**
* @author Acacia Dynamic
*  @copyright 2024 Acacia Dynamic
*  @license   private
*/
let actualTimer = 0;
let TimerTimeout = 3000;

function showSuccessMessage(message, prepend = true) {
    addElementInDigitalSignageInfosContainer(createDigitalSignageInfoElement(message), prepend);
}

function showErrorMessage(message, prepend = true) {
    addElementInDigitalSignageInfosContainer(createDigitalSignageInfoElement(message, true), prepend);
}

function createDigitalSignageInfoElement(message, isError = false) {

    let infoElement = document.createElement('div');
    infoElement.classList.add('digitalSignageInfo');
    infoElement.classList.add((isError) ? 'digitalSignageInfoError' : 'digitalSignageInfoSuccess');
    infoElement.innerHTML = message;

    actualTimer = actualTimer + TimerTimeout;

    setTimeout(
        () => {
            infoElement.parentElement.removeChild(infoElement);
            actualTimer = actualTimer - TimerTimeout;
            if (actualTimer < 0) {
                actualTimer = 0;
            }
        },
        actualTimer
    );

    return infoElement;
}

function addElementInDigitalSignageInfosContainer(element, prepend = true) {
    let infosContainer = getDigitalSignageInfosContainerElement();
    if (prepend) {
        infosContainer.prepend(element);
    } else {
        infosContainer.append(element);
    }
}

function getDigitalSignageInfosContainerElement() {

    let wpContent = document.getElementById('wpbody');

    if (!wpContent)
        wpContent = document.getElementById('content');

    let infosContainerId = 'digitalSignageInfos';
    if (wpContent.firstElementChild.id !== infosContainerId) {
        let infosContainer = document.createElement('div');
        infosContainer.id = infosContainerId;
        infosContainer.classList.add('digitalSignageInfos');
        wpContent.prepend(infosContainer);
    }

    return wpContent.firstElementChild;

}